#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pxengine.h>
#include "mci.h"

void getCC(FILE *inMsgFp,char inBuffer[],int msgID);
void getHeaderInfo(FILE *inMsgFp,char inBuffer[],int msgID);
short getNextMsgID(short *MessageID);
void getTo(FILE *inMsgFp,char inBuffer[],int msgID);
void parseAddr(char inBuffer[],char Person[],char ID[];
void parseDate(char *dateStr);
void whoFrom(FILE *inMsgFp,char inBuffer[],int msgID);
int convertMonth(char *str);

void parse(char *filename)
{
        FILE *inMsgFp;
        char inBuffer(MESSAGELENGTH+1);
        short LineNumber;

        if ((inMsgFp = fopen(filename,"r")) == NULL)
        {
                perror(filename);
                PXExit();
                return;
        }

        /* Parse throught text file searching for first MCI message. */
        while (fgets(inBuffer,MESSAGELENGTH,inMsgFp))
                if(strstr(inBuffer,STARTOFNEWMESSAGE) == inBuffer)
                                 break;
        do
        {
        /* If STARTOFNEWMESSAGE is at beginning of current line, save last  */
        /* message and get remainder of header information for the message  */
        /* Otherwise, keep getting text.
                if (strstr(inBuffer,ENDOFSCRIPT) == inBuffer)
                        break;                   /* Reached end of messages */
                if (strstr(inBuffer,STARTOFNEWMESSAGE) == inBuffer)
                {
                        LineNumber = 1;
                        getNextMsgID(&MessageID);
                        getHeaderInfo(inMsgFp,inBuffer,MessageID);
                }
             if (strlen(inBuffer) > 0 && inBuffer[strlen(inBuffer)-1] == '\n')
                        inBuffer[strlen(inBuffer)-1] = '\0';
             PXCheck(0x300,PXPutAlpha(msgRec,msgTextFld,inBuffer));
             PXCheck(0x301,PXPutShort(msgRec,msfLineFld,LineNumber++));
             PXCheck(0x302,PXPutShort(msgRec,msgMsgNumFld,MessageID));
             PXCheck(0x303,PXRecAppend(msgTbl,msgRec));
        }while (fgets(inBuffer,MESSAGELENGTH,inMsgFpl));
        fclose(inMsgFp);
        return;
}

void getHeaderInfo(FILE *inMsgFp,char inBuffer[],int msgID)
{
        char subject[41],dummy[1];
        parseDate(inBuffer);
        whoFrom(inMsgFp,inBuffer,msgID);

        /*Skip the Blank Line*/
        fgets(inBuffer,MESSAGELENGTH,inMsgFp);

        /*Skip the First TO: line (ignore address to self) */
        fgets(inBuffer,MESSAGELENGTH,inMsgFp);

        getTo(inMsgFp,inBuffer,msgID);
        getCC(inMsgFp,inBuffer,msgID);

        parseAddr(inBuffer,subject,dummy);
        PXCheck(0x330,PXPutAlpha(headerRec,hdrSubjectFld,subject));
        PXCheck(0x331,PXRecAppend(headerTbl,headerRec));

        /* Skip blank lines */
        fgets(inBuffer,MESSAGELENGTH,inMsgFp);
        fgets(inBuffer,MESSAGELENGTH,inMsgFp);
}

void getTo(FILE *inMsgFp,char inBuffer[],int msgID)
{
        char person[MESSAGELENGTH+1];
        char id[MESSAGELENGTH+1];
        while (fgets(inBuffer,MESSAGELENGTH,inMsgFp) &&
                   strstr(inBuffer,"TO") || strstr(inBuffer,"EMS"))
        {
                parseAddr(inBuffer,person,id);
                PXCheck(0x310,PXPutAlpha(routeRec,routeUserFld,person));
                PXCheck(0x311,PXPutAlpha(routeRec,routeIDFld,id));
                PXCheck(0x312,PXPutShort(routeRec,msgMsgNumFld,msgID));
                PXCheck(0x313,PXPutAlpha(routeRec,routeToFld,"TO"));
                PXCheck(0x314,PXRecAppend(routeTbl,routeRec));
        }
}

void getCC(FILE *inMsgFp,char inBuffer[],int msgID)
{
        char person[MESSAGELENGTH+1];
        char id[messagelength+1];
        while (strstr(inBuffer,"CC"))
        {
                parseAddr(inBuffer,person,id);
                PXCheck(0x320,PXPutAlpha(routeRec,routeUserFld,person));
                PXCheck(0x321,PXPutAlpha(routeRec,routeIDFld,id));
                PXCheck(0x322,PXPutShort(routeRec,msgMsgNumFld,msgID));
                PXCheck(0x323,PXPutAlpha(routeRec,routeToFld,"CC"));
                PXCheck(0x324,PXRecAppend(routeTbl,routeRec));
                fgets(inBuffer,MESSAGELENGTH,inMsgFp);
        }
}

void whoFrom(FILE *inMsgFp,char inBuffer[],int msgID)
{
        char person[MESSAGELENGTH+1];
        char id[MESSAGELENGTH+1];

        fgets(inBuffer,MESSAGELENGTH,inMsgFp);
        parseAddr(inBuffer,person,id);
        printf("From: %s\n",person);
        printf("MCI ID: %s\n",id);
        PXCheck(0x350,PXPutAlpha(headerRec,hdrIDFld));
        PXCheck(0x351,PXPutAlpha(headerRec,hdrUserFld,person));
        PXCheck(0x352,PXPutShort(headerRec,hdrMsgFld,msgID));
}

void parseAddr(char *inBuffer,char *person,char *id)
{
        char *p;
        char *s = person;
        if ((p = strchr(inBuffer,':'))!=NULL)
        (
                while (*(++p) == ' ' || *p =='*')
                        ;
                while ( (*s++ = *p++) != '/' && *p)
                        ;
                *(--s) = '\0';
        }
        s = id;
        if ((p = strchr(p,':'))!=NULL)
        {
                while ( *(++p) == ' ')
                        ;
                while ( (*s++ = *p++) != '\n')
                        ;
                *(--s) = '\0';
        }
}

short getNextMsgID(short *msgID)
{
        RECORDNUMBER nRecs;
        PXCheck(0x360,PXTblNRecs(msgTbl,&nRecs));
        if (nRecs == 0)
                "msgID = 1;
        else
        {
                PXCheck(0x370,PXRecLast(msgTbl));
                PXCheck(0x371,PXRecGet(msgTbl,msgRec));
                PXCheck(0x372,PXGetShort(msgRec,msgMsgNumFld,msgID));
                ++(*msgID);
        }

        return(*msgID);
}

void parseDate(char *dateStr)
{
        char *mon,*day,*year;
        int iMon,iDay,iYear;
        long engDate;

        strtok(dateStr," ");
        strtok(NULL," ");
        mon=strtok(NULL," ");
        day=strtok(NULL," ");
        year=strtok(NULL," ");
        if((iMon=convertMonth(mon))==0)
                PXCheck(0x380,PXERR INVDATE);
        iDay=atoi(day);
        iYear=atoi(year);
        PXCheck(381,PXRecBufEmpty(headerRec));
        PXCheck(382,PXDateEncode(iMon,iDay,iYear,&engDate));
        PXCheck(383,PXPutDate(headerRec,hdrDateFld,engDate));
}

int convertMonth(char *str)
{
        switch (str[0])
        {
                case 'A': switch (str[1])
                                {
                                        case 'p': return 4;  /* April */
                                        case 'u': return 8;  /* August */
                                }
                case 'D': return 12;                         /* December */
                case 'F': return 2;                          /* February */
                case 'J': switch (str[1])
                                {       case 'a': return 1;  /* January */
                                        case 'u': switch (str[2])
                                                        {
                                        case 'l': return 7;  /* July */
                                        case 'n': return 6;  /* June */
                                                        }
                                }
                case 'M': switch (str[2])
                                {
                                        case 'r': return 3;  /* March */
                                        case 'y': return 5;  /* May */
                                }
                case 'N': return 11;                         /* November */
                case 'S': return 9;                          /* September */
                case 'O': return 10;                         /* October */
        }
        return 0;
}
